/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _CLD_MSG_RPC_H_RPCGEN
#define _CLD_MSG_RPC_H_RPCGEN

#include <rpc/rpc.h>


#ifdef __cplusplus
extern "C" {
#endif

#define CLD_PKT_MAGIC "CLDc1pkt"
#define CLD_SID_SZ 8
#define CLD_INODE_NAME_MAX 256
#define CLD_MAX_USERNAME 32
#define CLD_MAX_PKT_MSG_SZ 1024
#define CLD_MAX_PAYLOAD_SZ 131072
#define CLD_MAX_MSG_SZ 196608
#define CLD_MAX_SECRET_KEY 128

enum cld_msg_op {
	CMO_NOP = 0,
	CMO_NEW_SESS = 1,
	CMO_OPEN = 2,
	CMO_GET_META = 3,
	CMO_GET = 4,
	CMO_PUT = 6,
	CMO_CLOSE = 7,
	CMO_DEL = 8,
	CMO_LOCK = 9,
	CMO_UNLOCK = 10,
	CMO_TRYLOCK = 11,
	CMO_ACK = 12,
	CMO_END_SESS = 13,
	CMO_PING = 14,
	CMO_NOT_MASTER = 15,
	CMO_EVENT = 16,
	CMO_ACK_FRAG = 17,
	CMO_AFTER_LAST = 17 + 1,
};
typedef enum cld_msg_op cld_msg_op;

enum cle_err_codes {
	CLE_OK = 0,
	CLE_SESS_EXISTS = 1,
	CLE_SESS_INVAL = 2,
	CLE_DB_ERR = 3,
	CLE_BAD_PKT = 4,
	CLE_INODE_INVAL = 5,
	CLE_NAME_INVAL = 6,
	CLE_OOM = 7,
	CLE_FH_INVAL = 8,
	CLE_DATA_INVAL = 9,
	CLE_LOCK_INVAL = 10,
	CLE_LOCK_CONFLICT = 11,
	CLE_LOCK_PENDING = 12,
	CLE_MODE_INVAL = 13,
	CLE_INODE_EXISTS = 14,
	CLE_DIR_NOTEMPTY = 15,
	CLE_INTERNAL_ERR = 16,
	CLE_TIMEOUT = 17,
	CLE_SIG_INVAL = 18,
};
typedef enum cle_err_codes cle_err_codes;

enum cld_open_modes {
	COM_READ = 0x01,
	COM_WRITE = 0x02,
	COM_LOCK = 0x04,
	COM_ACL = 0x08,
	COM_CREATE = 0x10,
	COM_EXCL = 0x20,
	COM_DIRECTORY = 0x40,
};
typedef enum cld_open_modes cld_open_modes;

enum cld_events {
	CE_UPDATED = 0x01,
	CE_DELETED = 0x02,
	CE_LOCKED = 0x04,
	CE_MASTER_FAILOVER = 0x08,
	CE_SESS_FAILED = 0x10,
};
typedef enum cld_events cld_events;

enum cld_inode_flags {
	CIFL_DIR = 0x01,
};
typedef enum cld_inode_flags cld_inode_flags;

enum cld_lock_flags {
	CLF_SHARED = 0x01,
};
typedef enum cld_lock_flags cld_lock_flags;

enum cld_pkt_order_t {
	CLD_PKT_ORD_MID = 0x0,
	CLD_PKT_ORD_FIRST = 0x1,
	CLD_PKT_ORD_LAST = 0x2,
	CLD_PKT_ORD_FIRST_LAST = 0x3,
};
typedef enum cld_pkt_order_t cld_pkt_order_t;
#define CLD_PKT_IS_FIRST 0x1
#define CLD_PKT_IS_LAST 0x2

struct cld_pkt_msg_infos {
	quad_t xid;
	enum cld_msg_op op;
};
typedef struct cld_pkt_msg_infos cld_pkt_msg_infos;

struct cld_pkt_msg_info {
	cld_pkt_order_t order;
	union {
		struct cld_pkt_msg_infos mi;
	} cld_pkt_msg_info_u;
};
typedef struct cld_pkt_msg_info cld_pkt_msg_info;

struct cld_pkt_hdr {
	quad_t magic;
	quad_t sid;
	char *user;
	struct cld_pkt_msg_info mi;
};
typedef struct cld_pkt_hdr cld_pkt_hdr;

struct cld_msg_generic_resp {
	enum cle_err_codes code;
	quad_t xid_in;
};
typedef struct cld_msg_generic_resp cld_msg_generic_resp;

struct cld_msg_ack_frag {
	quad_t seqid;
};
typedef struct cld_msg_ack_frag cld_msg_ack_frag;

struct cld_msg_open {
	int mode;
	int events;
	char *inode_name;
};
typedef struct cld_msg_open cld_msg_open;

struct cld_msg_open_resp {
	struct cld_msg_generic_resp msg;
	quad_t fh;
};
typedef struct cld_msg_open_resp cld_msg_open_resp;

struct cld_msg_get {
	quad_t fh;
};
typedef struct cld_msg_get cld_msg_get;

struct cld_msg_get_resp {
	struct cld_msg_generic_resp msg;
	quad_t inum;
	quad_t vers;
	quad_t time_create;
	quad_t time_modify;
	int flags;
	char *inode_name;
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct cld_msg_get_resp cld_msg_get_resp;

struct cld_msg_put {
	quad_t fh;
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct cld_msg_put cld_msg_put;

struct cld_msg_close {
	quad_t fh;
};
typedef struct cld_msg_close cld_msg_close;

struct cld_msg_del {
	char *inode_name;
};
typedef struct cld_msg_del cld_msg_del;

struct cld_msg_unlock {
	u_quad_t fh;
};
typedef struct cld_msg_unlock cld_msg_unlock;

struct cld_msg_lock {
	quad_t fh;
	int flags;
};
typedef struct cld_msg_lock cld_msg_lock;

struct cld_msg_event {
	quad_t fh;
	int events;
};
typedef struct cld_msg_event cld_msg_event;

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_cld_msg_op (XDR *, cld_msg_op*);
extern  bool_t xdr_cle_err_codes (XDR *, cle_err_codes*);
extern  bool_t xdr_cld_open_modes (XDR *, cld_open_modes*);
extern  bool_t xdr_cld_events (XDR *, cld_events*);
extern  bool_t xdr_cld_inode_flags (XDR *, cld_inode_flags*);
extern  bool_t xdr_cld_lock_flags (XDR *, cld_lock_flags*);
extern  bool_t xdr_cld_pkt_order_t (XDR *, cld_pkt_order_t*);
extern  bool_t xdr_cld_pkt_msg_infos (XDR *, cld_pkt_msg_infos*);
extern  bool_t xdr_cld_pkt_msg_info (XDR *, cld_pkt_msg_info*);
extern  bool_t xdr_cld_pkt_hdr (XDR *, cld_pkt_hdr*);
extern  bool_t xdr_cld_msg_generic_resp (XDR *, cld_msg_generic_resp*);
extern  bool_t xdr_cld_msg_ack_frag (XDR *, cld_msg_ack_frag*);
extern  bool_t xdr_cld_msg_open (XDR *, cld_msg_open*);
extern  bool_t xdr_cld_msg_open_resp (XDR *, cld_msg_open_resp*);
extern  bool_t xdr_cld_msg_get (XDR *, cld_msg_get*);
extern  bool_t xdr_cld_msg_get_resp (XDR *, cld_msg_get_resp*);
extern  bool_t xdr_cld_msg_put (XDR *, cld_msg_put*);
extern  bool_t xdr_cld_msg_close (XDR *, cld_msg_close*);
extern  bool_t xdr_cld_msg_del (XDR *, cld_msg_del*);
extern  bool_t xdr_cld_msg_unlock (XDR *, cld_msg_unlock*);
extern  bool_t xdr_cld_msg_lock (XDR *, cld_msg_lock*);
extern  bool_t xdr_cld_msg_event (XDR *, cld_msg_event*);

#else /* K&R C */
extern bool_t xdr_cld_msg_op ();
extern bool_t xdr_cle_err_codes ();
extern bool_t xdr_cld_open_modes ();
extern bool_t xdr_cld_events ();
extern bool_t xdr_cld_inode_flags ();
extern bool_t xdr_cld_lock_flags ();
extern bool_t xdr_cld_pkt_order_t ();
extern bool_t xdr_cld_pkt_msg_infos ();
extern bool_t xdr_cld_pkt_msg_info ();
extern bool_t xdr_cld_pkt_hdr ();
extern bool_t xdr_cld_msg_generic_resp ();
extern bool_t xdr_cld_msg_ack_frag ();
extern bool_t xdr_cld_msg_open ();
extern bool_t xdr_cld_msg_open_resp ();
extern bool_t xdr_cld_msg_get ();
extern bool_t xdr_cld_msg_get_resp ();
extern bool_t xdr_cld_msg_put ();
extern bool_t xdr_cld_msg_close ();
extern bool_t xdr_cld_msg_del ();
extern bool_t xdr_cld_msg_unlock ();
extern bool_t xdr_cld_msg_lock ();
extern bool_t xdr_cld_msg_event ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_CLD_MSG_RPC_H_RPCGEN */
